"""
Cuchulufm is a series of wrappers for bottle, mako and others and construct a simple headless cms.

Copyright (C) 2023 Antonio de la Rosa Caballero

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

from cuchulu.libraries.db.corefields import CharField
import re

mail_pattern=re.compile(r"\w[\w\.-]*@\w[\w\.-]+\.\w+")

class EmailField(CharField):
    """Field for save and check email addreses"""
    
    def __init__(self, name, size=1024, required=False):
        
        super().__init__(name, size, required)
        
        self.error_default='Error: No valid format'       
        
        self.jformat='email' 
    
    def check(self, value):
        
        value=super().check(value)
        
        self.error=False
        self.txt_error=''
        
        if not mail_pattern.match(value):
            
            self.error=True
            value=""
            self.txt_error=self.error_default
            
        return value
